#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
###2004-0309 - Connview v.0.2 mod by catastrophe (initial release)
# - Intended for use on Smoothwall Express 2.0 p2 ui-3.6.1 (kernel 2.4.25)
# - Inspired by the connects.cgi mod by DavidVT
# - Utilizes unmodified CONNTRACK-VIEWER v1.3 by Patrick Lagace (cv.intellos.net) 
# - Implementation of v2.1 pack system by Tiago Freitas Leal 
# - Added name resolution "on/off" option
###2004-0319 - Connview v.0.3 mod by catastrophe
# - Uses modified conntrack-viewer.pl
# - Added color support (green,orange,red,white,grey)
# - Added name resolution truncation checkbox
# - Added 'dumb' forward/reverse sorting by column via temporary file
# - Utilizes a modified conntrack-viewer.pl script to support the new features
# - Added icmp interpretation section to tame icmp output
###2004-0403 - Connview v.0.4 mod by catastrophe
# - Renamed modified conntrack-viewer.pl to conntrack-viewer-CAT.pl
# - Added selectable page refresh rate (0ff,30s,300s,600s,1800s,3600s)
# - Cleaned up output, fixed 'tab' glitch that shifted out with MSIE6
# - 'Smart' IP sorting using ip2number 'pre-sort' routine from DHCP Pack v1.2 (dhcplease.pl 
#    by Dane Robert Jones and Tiago Freitas Leal)
# - 'Smart' port sorting by enabling -n during sorting
###2004-0505 - Connview v.0.5 mod by catastrophe
# - Reworked display into using 'html tables' rather than using 'spacing' (with name resolution 
#    each entry takes two lines, state may be represented with graphic)
# - When Sort by is 'None', temporary sorting file no longer generated.
# - Added "Connection summary" section
# - Added "Views" which allows for Both, Masq, Direct, and Mixed viewing modes
# - Raw /proc/net/ip_conntrack output section added
# - Fixed some variable initialization problems
# - Source and remote ip checkboxes for use with "Lookup" and "Add to IP block list" from 
#    firewalllog.dat by The Smoothwall Team
# - Enlarged font for IP addresses and ports for easy viewing on high resolution monitors
# - Hide UDP, TCP, or Other connection entries
###2004-0919 - Connview v.0.6 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 p4 ui-3.6.1 (kernel v2.4.27)
# - Fixed incorrect "protocol name" displayed during 'unknown' protocol interpretation
# - Special thanks to ehoiting and daniel_hozac for modding & compiling versions of 
#    Cutter v1.02 (by Chris Lowth) for use with Connview
# - Incorporated "Cutter support" code by Daniel Hokka Zakrisson (daniel_hozac) 
#    to "cut" specific connection(s) based on "ip-address-1 port-1 ip-address-2 port-2" (Nice!)
# - Added "Lookup" and "Add to IP block list" code updates by Daniel Hokka Zakrisson (daniel_hozac)
# - Data gathering from ip_conntrack done by helper file to overcome "permission change" introduced 
#    by kernel 2.4.27 in Fixes 4 (Thanks SwampKracker, daniel_hozac, & NetWhiz)
# - Stripped connviewhelper to reduce file size (thanks NetWhiz)
# - Fixed "/bin/sort: field number is zero: invalid field specification `0.1'" bug
# - Truncation of resolved names from the left so the TLD can be viewed
# - Truncation of port names as well when truncation checkbox ticked
# - Fixed parsing problems for TCP & UDP because of extra "mark=0" with SK 2.4.27 (Thanks lucasl & foxhound)
# - Incorporated 2004-09-03 "Various smaller fixes and modsys packaging things" by Daniel Hokka Zakrisson
#    (includes improved "page refresh" code and finalized protocol interpretation fix for SK 2.4.27)
# - Incorporated 2004-0919 "modsys fixes" by Daniel Hokka Zakrisson
###2005-0616 - Connview v.0.7 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 fixes7 ui-3.6.1 (kernel v2.4.30)
# - Added "page generated in 'x' seconds" (thanks daniel_hozac) and 'hide alertbox' variable
# - Tweaked so compatible with sylvester's blackcurrant color mod
# - Added "Summary Only", "Raw Only", and "Netstat" views
# - Added gre pptp protocol interpretation with SK 2.4.30 compatibility (thanks BoHiCa)
# - Connection summary for TCP now includes "mouse-over" showing 'established' connections
# - Incorporated "in script sorting" code contributed by Daniel Hokka Zakrisson (daniel_hozac)
# - 'Unified' protocol interpretation & other tweaks to substantially improve "in script sorting" performance
###2007-0805 - Connview v.0.8-test1 mod by catastrophe
# - Added rc.sysinit Tweak by BoHiCa to "Allieviate p2p Conntrack Constipation on SmoothWall2"
# - Added cutter.tgz, ehoiting modded version of cutter by Chris Lowth
#
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###





############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

if ($ENV{'QUERY_STRING'})
{
	$_ = $ENV{'QUERY_STRING'};
	my $action;
	$_ =~ s/\+/ /g;
	my @temp = split(/\&/);
	my @conns;
	foreach $_ (@temp)
	{
		($var, $val) = split(/\=/);
		# from /var/smoothwall/header.pl:getcgihash
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack('C', hex($1))/eg;
		# end /var/smoothwall/header.pl:getcgihash
		if ($var eq 'ACTION') {
			$action = $val; }
		if ($var eq 'conn') {
			if ($val =~ m#^([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}):([0-9]{1,5})/([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}):([0-9]{1,5})\((s|d)\)$#)
			{
				push(@conns, [ ($1, $2, $3, $4, $5) ]);
			}
		}
	}

	if ($action eq $tr{'add to ip block'})
	{
		my $ips = "";
		for $ref (@conns)
		{
			$ips .= "&ip=" . ($$ref[4] eq 's' ? $$ref[0] : $$ref[2]);
		}

		print "Status: 302 Moved\n";
		print "Location: /cgi-bin/ipblock.cgi?$ips\n\n";
		exit 0;
	}
	if ($action eq $tr{'lookup'})
	{
		my $ips = "";
		for $ref (@conns)
		{
			$ips .= "&ip=" . ($$ref[4] eq 's' ? $$ref[0] : $$ref[2]);
		}

		print "Status: 302 Moved\n";
		print "Location: /cgi-bin/ipinfo.cgi?$ips\n\n";
		exit 0;
	}
	if ($action eq $tr{'conn cutter'} && -x "/usr/local/bin/cutter")
	{
		for $ref (@conns)
		{
			$command = "/usr/local/bin/cutter " . join(" ", @$ref);
			open(TEMPerr, ">>/tmp/connviewERROR") or die 'Unable to open temporary file.';	###debugging
			flock(TEMPerr, 2);										###debugging
			print TEMPerr "$command\n";									###debugging
			close(TEMPerr);										###debugging

			system($command);
		}
	}
}

$connviewsettings{'ACTION'} = '';
$connviewsettings{'CONN_DISPLAY'} = 'mixed';
$connviewsettings{'CONN_NAME'} = 'off';
$connviewsettings{'CONN_COLOR'} = 'off';
$connviewsettings{'CONN_TRUNCATE'} = 'off';
$connviewsettings{'CONN_SORT'} = 'on';
$connviewsettings{'CONN_COLUMN'} = '0';
$connviewsettings{'CONN_REFRESH'} = '0';
$connviewsettings{'CONN_HIDEUDP'} = 'off';
$connviewsettings{'CONN_HIDETCP'} = 'off';
$connviewsettings{'CONN_HIDEOTHER'} = 'off';
$connviewsettings{'CONN_REVERSE'} = 'off';
$connviewsettings{'CONN_RAW'} = 'off';
$connviewsettings{'CONN_TRUNCATE_LEFT'} = 'on';
$connviewsettings{'CONN_HIDE_ALERTBOX'} = 'off';
&getcgihash(\%connviewsettings);

my $errormessage = '';

if ($connviewsettings{'ACTION'} eq $tr{'update'})
{
	if ($connviewsettings{'CONN_COLUMN'} eq 0) {
 		$connviewsettings{'CONN_SORT'}='off';
	}
	&writehash("${swroot}/preferences/connview", \%connviewsettings);
}

system ("/bin/touch ${swroot}/preferences/connview");
&readhash("${swroot}/preferences/connview", \%connviewsettings);

$checked{'CONN_NAME'}{'on'} = '';
$checked{'CONN_NAME'}{'off'} = '';
$checked{'CONN_NAME'}{$connviewsettings{'CONN_NAME'}} = 'CHECKED';

$checked{'CONN_COLOR'}{'on'} = '';
$checked{'CONN_COLOR'}{'off'} = '';
$checked{'CONN_COLOR'}{$connviewsettings{'CONN_COLOR'}} = 'CHECKED';

$checked{'CONN_SORT'}{'on'} = '';
$checked{'CONN_SORT'}{'off'} = '';
$checked{'CONN_SORT'}{$connviewsettings{'CONN_SORT'}} = 'CHECKED';

$checked{'CONN_REVERSE'}{'on'} = '';
$checked{'CONN_REVERSE'}{'off'} = '';
$checked{'CONN_REVERSE'}{$connviewsettings{'CONN_REVERSE'}} = 'CHECKED';

$selected{'CONN_COLUMN'}{'0'} = '';
$selected{'CONN_COLUMN'}{'1'} = '';
$selected{'CONN_COLUMN'}{'2'} = '';
$selected{'CONN_COLUMN'}{'3'} = '';
$selected{'CONN_COLUMN'}{'4'} = '';
$selected{'CONN_COLUMN'}{'5'} = '';
$selected{'CONN_COLUMN'}{'6'} = '';
$selected{'CONN_COLUMN'}{'7'} = '';
$selected{'CONN_COLUMN'}{$connviewsettings{'CONN_COLUMN'}} = 'SELECTED';

$checked{'CONN_TRUNCATE'}{'on'} = '';
$checked{'CONN_TRUNCATE'}{'off'} = '';
$checked{'CONN_TRUNCATE'}{$connviewsettings{'CONN_TRUNCATE'}} = 'CHECKED';

$selected{'CONN_REFRESH'}{'0'} = '';
$selected{'CONN_REFRESH'}{'5'} = '';
$selected{'CONN_REFRESH'}{'10'} = '';
$selected{'CONN_REFRESH'}{'30'} = '';
$selected{'CONN_REFRESH'}{'60'} = '';
$selected{'CONN_REFRESH'}{'120'} = '';
$selected{'CONN_REFRESH'}{'300'} = '';
$selected{'CONN_REFRESH'}{'600'} = '';
$selected{'CONN_REFRESH'}{'1800'} = '';
$selected{'CONN_REFRESH'}{'3600'} = '';
$selected{'CONN_REFRESH'}{$connviewsettings{'CONN_REFRESH'}} = 'SELECTED';

$selected{'CONN_DISPLAY'}{'both'} = '';
$selected{'CONN_DISPLAY'}{'masq'} = '';
$selected{'CONN_DISPLAY'}{'direct'} = '';
$selected{'CONN_DISPLAY'}{'mixed'} = '';
$selected{'CONN_DISPLAY'}{$connviewsettings{'CONN_DISPLAY'}} = 'SELECTED';

$checked{'CONN_RAW'}{'on'} = '';
$checked{'CONN_RAW'}{'off'} = '';
$checked{'CONN_RAW'}{$connviewsettings{'CONN_RAW'}} = 'CHECKED';

$checked{'CONN_HIDEUDP'}{'on'} = '';
$checked{'CONN_HIDEUDP'}{'off'} = '';
$checked{'CONN_HIDEUDP'}{$connviewsettings{'CONN_HIDEUDP'}} = 'CHECKED';

$checked{'CONN_HIDETCP'}{'on'} = '';
$checked{'CONN_HIDETCP'}{'off'} = '';
$checked{'CONN_HIDETCP'}{$connviewsettings{'CONN_HIDETCP'}} = 'CHECKED';

$checked{'CONN_HIDEOTHER'}{'on'} = '';
$checked{'CONN_HIDEOTHER'}{'off'} = '';
$checked{'CONN_HIDEOTHER'}{$connviewsettings{'CONN_HIDEOTHER'}} = 'CHECKED';

&connviewREFRESHset();

&showaboutsection();
#&showmodssection();		###modsys

&openbigbox('100%', 'LEFT');

if ($connviewsettings{'CONN_HIDE_ALERTBOX'} eq 'on') {
	###then do nothing
} else {
	&alertbox($errormessage);
}

##########
###MAIN###
##########

&openbox('100%', 'LEFT', $tr{'conntrack viewerc'});

print qq|
<FORM METHOD='POST' ACTION='/cgi-bin/connview.cgi'>
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<TR>
	<TD CLASS='base'>$tr{'conn displayc'}
	<SELECT NAME='CONN_DISPLAY'>
		<OPTION VALUE='both' $selected{'CONN_DISPLAY'}{'both'}>Both
		<OPTION VALUE='masq' $selected{'CONN_DISPLAY'}{'masq'}>Masq
		<OPTION VALUE='direct' $selected{'CONN_DISPLAY'}{'direct'}>Direct
		<OPTION VALUE='mixed' $selected{'CONN_DISPLAY'}{'mixed'}>Mixed
		<OPTION VALUE='summary' $selected{'CONN_DISPLAY'}{'summary'}>Summary
		<OPTION VALUE='raw' $selected{'CONN_DISPLAY'}{'raw'}>Raw
		<OPTION VALUE='netstat' $selected{'CONN_DISPLAY'}{'netstat'}>Netstat
	</SELECT>

	$tr{'conn namec'}
	<INPUT TYPE='checkbox' NAME='CONN_NAME' $checked{'CONN_NAME'}{'on'}>
	$tr{'conn colorc'}
	<INPUT TYPE='checkbox' NAME='CONN_COLOR' $checked{'CONN_COLOR'}{'on'}>
	$tr{'conn truncatec'}
	<INPUT TYPE='checkbox' NAME='CONN_TRUNCATE' $checked{'CONN_TRUNCATE'}{'on'}>
	</TD>

	<TD CLASS='base'>$tr{'conn sortc'}
	<SELECT NAME='CONN_COLUMN'>
		<OPTION VALUE='0' $selected{'CONN_COLUMN'}{'0'}>None
		<OPTION VALUE='1' $selected{'CONN_COLUMN'}{'1'}>Protocol
		<OPTION VALUE='9' $selected{'CONN_COLUMN'}{'9'}>Source IP
		<OPTION VALUE='3' $selected{'CONN_COLUMN'}{'3'}>Source Port
		<OPTION VALUE='10' $selected{'CONN_COLUMN'}{'10'}>Remote IP
		<OPTION VALUE='5' $selected{'CONN_COLUMN'}{'5'}>Remote Port
		<OPTION VALUE='6' $selected{'CONN_COLUMN'}{'6'}>Service
		<OPTION VALUE='7' $selected{'CONN_COLUMN'}{'7'}>State
	</SELECT>
	</TD>

	<TD CLASS='base'>$tr{'conn refreshc'}
	<SELECT NAME='CONN_REFRESH'>
		<OPTION VALUE='0' $selected{'CONN_REFRESH'}{'0'}>Off
		<OPTION VALUE='30' $selected{'CONN_REFRESH'}{'30'}>30s
		<OPTION VALUE='300' $selected{'CONN_REFRESH'}{'300'}>300s
		<OPTION VALUE='600' $selected{'CONN_REFRESH'}{'600'}>600s
		<OPTION VALUE='1800' $selected{'CONN_REFRESH'}{'1800'}>1800s
		<OPTION VALUE='3600' $selected{'CONN_REFRESH'}{'3600'}>3600s
	</SELECT>
	</TD>

	<TD WIDTH='15%' ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'update'}'></TD>
</TR>
<TR>
	<TD CLASS='base'>$tr{'conn hidec'}
	<INPUT TYPE='checkbox' NAME='CONN_HIDEUDP' $checked{'CONN_HIDEUDP'}{'on'}>UDP
	<INPUT TYPE='checkbox' NAME='CONN_HIDETCP' $checked{'CONN_HIDETCP'}{'on'}>TCP
	<INPUT TYPE='checkbox' NAME='CONN_HIDEOTHER' $checked{'CONN_HIDEOTHER'}{'on'}>Other
	</TD>

	<TD CLASS='base'>$tr{'conn reversec'}
	<INPUT TYPE='checkbox' NAME='CONN_REVERSE' $checked{'CONN_REVERSE'}{'on'}>
	</TD>

	<TD CLASS='base'>$tr{'conn showrawc'}
	<INPUT TYPE='checkbox' NAME='CONN_RAW' $checked{'CONN_RAW'}{'on'}></TD>
</TR>
</TABLE>
</FORM>
|;

&closebox();

print "<FORM METHOD='GET'>\n";
	system ('/usr/local/bin/conntrack-viewer-CAT.pl');
print "</FORM>";

&closebigbox();
&closepage();

$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";

##########
###DONE###
##########





#################
###SUBROUTINES###
#################

sub connviewREFRESHset {
	my $refresh = $connviewsettings{'CONN_REFRESH'};
	if ($refresh > 0)
	{
		print "Refresh: $refresh\n";
		print "Cache-Control: no-cache\n";
		print "Pragma: no-cache\n";
	}
	&showhttpheaders();
	$t0 = gettimeofday();
	&openpage($tr{'conn conntrack'}, 1, '', 'about your smoothie');
#	&openpage($tr{'conn conntrack'}, 1, '', 'mods');			###modsys
}
